    /*
     * extend day_dim.sql
     * $Id: load_day_dim.sql,v 1.0 2017/02/16 18:57:10 oracle Exp $
     * Copyright Info Here
     *
     * > sqlplus cccuser/password @ Extend_Day_Dim_DateRange.sql
     */

set serveroutput on;
	 
alter session set nls_TERRITORY="AMERICA";
alter session set nls_LANGUAGE="AMERICAN";
define owner=&1;

declare
    dDate             date;
    dStartDate        date := to_date('01/02/2021','MM/DD/YYYY');
    nLoopCount        INTEGER :=  3651;
    DateRec           &&owner..DAY_DIM%rowtype;
    nWeekCounter      integer := 1;
    nWeekMonthCounter integer := 1;
    nMonthCounter     integer := 1;
BEGIN
    for nDayCount in 0..nLoopCount loop
        dDate := dStartDate + nDayCount;
        DateRec.day_dim_id := to_char(dDate,'YYYYMMDD');
        DateRec.FULL_DATE := dDate;
        DateRec.DAY_OF_WEEK := trim(to_char(dDate,'Day'));
        DateRec.DAY_NUM_CAL_MON := to_char(dDate,'DD');
        DateRec.DAY_NUM_CAL_YEAR := to_char(dDate,'DDD');
        if to_char(dDate,'D') = 7 then
            DateRec.LAST_DAY_IN_WEEK := 'Y';
        else
            DateRec.LAST_DAY_IN_WEEK := 'N';
        end if;
        if last_day(dDate) = dDate then
            DateRec.LAST_DAY_IN_MONTH := 'Y';
        else
            DateRec.LAST_DAY_IN_MONTH := 'N';
        end if;
        if to_char(dDate,'D') = 1 then
            DateRec.FIRST_DAY_IN_WEEK := 'Y';
        else
            DateRec.FIRST_DAY_IN_WEEK := 'N';
        end if;
        if to_char(dDate,'DD') = '01' then
            DateRec.FIRST_DAY_IN_MONTH := 'Y';
        else
            DateRec.FIRST_DAY_IN_MONTH := 'N';
        end if;
        DateRec.CAL_WEEK_END_DATE := dDate + (7-to_char(dDate,'D'));
        DateRec.CAL_WEEK_BEGIN_DATE := dDate - (to_char(dDate,'D')-1);
        DateRec.CAL_MON_NUM_IN_YEAR := ltrim(to_char(dDate,'MM'),'0');
        -- New year so reset week and month counters to 1
        if to_char(dDate,'DDD') = 1 then
            nWeekCounter := 1;
            nWeekMonthCounter := 1;
            nMonthCounter := 1;
        elsif DateRec.DAY_OF_WEEK = 'Sunday' then
            nWeekCounter := nWeekCounter + 1;
            -- Week 4 or greater, so need to make decision whether to start new month 
            if nWeekMonthCounter >= 4  then
                if (last_day(dDate) - dDate < 4 or
                   DateRec.CAL_MON_NUM_IN_YEAR > nMonthCounter) and nMonthCounter <> 12 then
                    nWeekMonthCounter := 1;
                    dbms_output.put_line('incremented month');
                    dbms_output.put_line(DateRec.FULL_DATE);
                    dbms_output.put_line('DateRec.CAL_MON_NUM_IN_YEAR:'||DateRec.CAL_MON_NUM_IN_YEAR);
                    dbms_output.put_line('nMonthCounter:'||nMonthCounter);
                    nMonthCounter := nMonthCounter + 1;
                else
                    nWeekMonthCounter := nWeekMonthCounter + 1;
                end if;
            else
                nWeekMonthCounter := nWeekMonthCounter + 1;
            end if;
        end if;
        DateRec.CAL_WEEK_NUM_IN_YEAR := nWeekCounter;
        DateRec.CAL_MONTH_NAME := to_char(dDate,'Month');
        DateRec.CAL_YEAR_MON := to_char(dDate,'YYYY-MM');
        DateRec.CAL_QUARTER := to_char(dDate,'Q');
        DateRec.CAL_YEAR_QUARTER := 'Q'||to_char(dDate,'Q')||'-'||to_char(dDate,'YYYY');
        if to_char(dDate,'Q') < 3 then
            DateRec.CAL_HALF_YEAR := 'First Half-'||to_char(dDate,'YYYY');
        else
            DateRec.CAL_HALF_YEAR := 'Last Half-'||to_char(dDate,'YYYY');
        end if;
        DateRec.CAL_YEAR := to_char(dDate,'YYYY');
        DateRec.HOLIDAY_INDICATOR := 'N';
        if to_char(dDate,'D') not in (1,7) then
            DateRec.WEEKEND_INDICATOR := 'N';
        else
            DateRec.WEEKEND_INDICATOR := 'Y';
        end if;
        DateRec.DAY_NUM_IN_WEEK := to_char(dDate,'D');
        insert into &&owner..day_dim
            (day_dim_id,
             FULL_DATE, DAY_OF_WEEK,
             DAY_NUM_CAL_MON, DAY_NUM_CAL_YEAR,
             LAST_DAY_IN_WEEK, LAST_DAY_IN_MONTH,
             FIRST_DAY_IN_WEEK, FIRST_DAY_IN_MONTH,
             CAL_WEEK_END_DATE, CAL_WEEK_BEGIN_DATE,
             CAL_WEEK_NUM_IN_YEAR, CAL_MONTH_NAME,
             CAL_MON_NUM_IN_YEAR, CAL_YEAR_MON,
             CAL_QUARTER, CAL_YEAR_QUARTER,
             CAL_HALF_YEAR, CAL_YEAR,
             HOLIDAY_INDICATOR, WEEKEND_INDICATOR,
             DAY_NUM_IN_WEEK)
          values
            (DateRec.day_dim_ID,DateRec.FULL_DATE,
             DateRec.DAY_OF_WEEK,
             DateRec.DAY_NUM_CAL_MON, DateRec.DAY_NUM_CAL_YEAR,
             DateRec.LAST_DAY_IN_WEEK, DateRec.LAST_DAY_IN_MONTH,
             DateRec.FIRST_DAY_IN_WEEK, DateRec.FIRST_DAY_IN_MONTH,
             DateRec.CAL_WEEK_END_DATE, DateRec.CAL_WEEK_BEGIN_DATE,
             DateRec.CAL_WEEK_NUM_IN_YEAR, DateRec.CAL_MONTH_NAME,
             DateRec.CAL_MON_NUM_IN_YEAR, DateRec.CAL_YEAR_MON,
             DateRec.CAL_QUARTER, DateRec.CAL_YEAR_QUARTER,
             DateRec.CAL_HALF_YEAR, DateRec.CAL_YEAR,
             DateRec.HOLIDAY_INDICATOR, DateRec.WEEKEND_INDICATOR,
             DateRec.DAY_NUM_IN_WEEK);
    end loop;
    commit;
end;
/